#ifndef NESsystemHH
#define NESsystemHH

#include "sizes.h"

extern class Audio
{
public:
	inline unsigned Hz() const { return _hz; }
	inline BYTE chancount() const { return _stereo ? 2 : 1; }
	inline BYTE bits() const { return _bits; }
public:
	Audio();
	~Audio();
	void Write(BYTE value);
	void Write(BYTE value, unsigned count);
	void Write(SWORD value);
	void Write(SWORD value, unsigned count);
	void Write(SWORD left, SWORD right);
	void Write(SWORD left, SWORD right, unsigned count);
	void Write(BYTE left, BYTE right);
	void Write(BYTE left, BYTE right, unsigned count);
private:
	unsigned _hz;
	bool _stereo;
	BYTE _bits;
	int fd;
} AudioSystem;

#if 0
extern class Video
{
public:
	Video();
	~Video();
	void GenPal(double hue, double tint);
	void PSet(fWORD x, fWORD y, fBYTE val);
private:
	struct {BYTE r,g,b; } palitem;
	palitem palette[64];
} VideoSystem;

extern class Input
{
public:
} InputSystem;
#endif

#endif
